---------------------------------------------
--     
--
-- http://quik2dde.ru/
--
-- ver: 0.1
---------------------------------------------

-- TODO -- ,      ,   , . ProcessExistPositions()
-- TODO --   "  "
-- TODO --   
-- TODO --       Options={"goFixedVertLine","goFixedHorzLine","goVertLine","goHorzLine","goRangeS"}
-- TODO --    ( ?)
-- TODO --    
-- TODO --       

require "vcl"


--- Create form ---

mainForm = VCL.Form("mainForm")

mainForm.Caption = "   "
mainForm._= { position="podesktopcenter", height=500, width=850,
              OnClose="MainFormClose" }
--              OnCloseQuery="MainFormCloseQuery" }

--pnl1 = VCL.Panel(mainForm,"pnl1")
--pnl1._ = { align = "alTop", Caption = "Positions" }

gridPos = VCL.StringGrid(mainForm,"gridPos")
gridPos._ = { Top = 1, Height = 200, RowCount = 3, AutoEdit = False, FixedCols = 1, FixedRows = 1, Flat = True }

gridPos:SetColParams({
  {Width=100, Alignment="taRightJustify", Title={Caption="", Alignment="taCenter"}},
  {Width=100, Alignment="taRightJustify", Title={Caption=" ", Alignment="taCenter"}},
  {Width=100, Alignment="taRightJustify", Title={Caption="", Alignment="taCenter"}},
  {Width=100, Alignment="taRightJustify", Title={Caption="/", Alignment="taCenter"}},
})

split = VCL.Splitter(mainForm,"split")
split._ = { Top = 5 }


--pnl2 = VCL.Panel(mainForm,"pnl2")
--pnl2._ = { align = "alTop", Caption = "Trades" }

gridTrades = VCL.StringGrid(mainForm,"gridTrades")
gridTrades._ = { Top = 5, ColCount = 10, RowCount = 1, AutoEdit = False, FixedCols = 1, FixedRows = 1, Flat = True }

gridTrades:SetColParams({
  {Width= 50, Alignment="taRightJustify", Title={Caption="", Alignment="taCenter"}},
  {Width=100, Alignment="taRightJustify", Title={Caption="", Alignment="taCenter"}},
  {Width=100, Alignment="taRightJustify", Title={Caption="", Alignment="taCenter"}},
  {Width= 30, Alignment="taCenter", Title={Caption="B/S", Alignment="taCenter"}},
  {Width=120, Alignment="taRightJustify", Title={Caption=" ", Alignment="taCenter"}},
  {Width=100, Alignment="taRightJustify", Title={Caption=" ", Alignment="taCenter"}},
  {Width=130, Alignment="taRightJustify", Title={Caption="", Alignment="taCenter"}},
  {Width=130, Alignment="taRightJustify", Title={Caption="% ", Alignment="taCenter"}},
})

gridPos.align = "alTop" 
split.align = "alTop" 
gridTrades.align = "alClient"


--- Fill default data ---

summ_pos_row_num = 2
gridPos_data = {}  -- : _, : { .RowNum  .Pos  .Avr  .Comm  .PnL }


--- Util Functions ---

function FillPosGridSummRow()
  gridPos.RowCount = summ_pos_row_num+1

  local i
  for i = 0, 4 do
    gridPos:SetCell(i, summ_pos_row_num - 1, "")
  end
  gridPos:SetCell(2, summ_pos_row_num, "")

  gridPos:SetCell(0, summ_pos_row_num, ":")

  local sec, elem
  local pos, comm, s = 0,0,0
  for sec,elem in pairs(gridPos_data) do
    pos  = pos  + elem.Pos
    comm = comm + elem.Comm
    s    = s    + elem.PnL
  end
  gridPos:SetCell(1, summ_pos_row_num, tostring(pos))
  gridPos:SetCell(3, summ_pos_row_num, tostring(comm))
  gridPos:SetCell(4, summ_pos_row_num, tostring(s))
end


function TestBit(x, bit_num)   -- bit_num: 0-based indexing
  local p = 2 ^ bit_num
  return x % (p + p) >= p
end


function GetBuySell(flags)
  if TestBit(flags, 2) then
    return 'S'
  else
    return 'B'
  end
end


function GetLotSize(class, sec)
  local res = getParamEx(class, sec, "LOTSIZE")
  if res == nil then
    res = 1
  else
    if (res.param_type == 1) or (res.param_type == 2) then
      res = res.param_value
    else
      res = 1
    end
  end

  return res
end


function OutPosGridLine(seccode, elem)
  gridPos:SetCell(0, elem.RowNum, seccode)
  gridPos:SetCell(1, elem.RowNum, tostring(elem.Pos))
  gridPos:SetCell(2, elem.RowNum, tostring(elem.Avr))
  gridPos:SetCell(3, elem.RowNum, tostring(elem.Comm))
  gridPos:SetCell(4, elem.RowNum, tostring(elem.PnL))
end

function AddNewPosData(seccode, qty, avr, comm)
  local elem = {}

  elem.RowNum = summ_pos_row_num - 1
  elem.Pos = qty
  elem.Avr = avr
  elem.Comm = comm
  elem.PnL = 0

  gridPos_data[seccode] = elem
  summ_pos_row_num = summ_pos_row_num + 1

  return elem
end


function ProcessExistPositions()
  local SPOT_POSITIONS_TABLE_NAME = "depo_limits"

  local positions_num = getNumberOf(SPOT_POSITIONS_TABLE_NAME)
  local i
  for i = 0, positions_num-1 do
    local position = getItem(SPOT_POSITIONS_TABLE_NAME, i)
    local elem = AddNewPosData(position.sec_code, position.openbal, position.awg_position_price , 0)
    OutPosGridLine(position.sec_code, elem)
    FillPosGridSummRow()
  end
end


function ProcessTrade(trade)

  -- update positions table

  local Lot = GetLotSize(trade.classcode, trade.seccode)
  local BuySell = GetBuySell(trade.flags)
  local prevAvr = 0
  local isClosePos = false

  local elem = gridPos_data[trade.seccode]
  if elem == nil then

    -- insert new row

    local qty
    if BuySell == 'B' then
      qty = trade.qty
    else
      qty = -trade.qty
    end

    local comm = trade.clearing_comission + trade.exchange_comission + trade.tech_center_comission

    elem = AddNewPosData(trade.seccode, qty, trade.price, comm)

  else

    -- update row

    if  ( (BuySell == 'B') and (elem.Pos < 0) )
     or ( (BuySell == 'S') and (elem.Pos > 0) )
    then
      elem.PnL = trade.price - elem.Avr
      isClosePos = true
    end

    prevAvr = elem.Avr
    prevPos = elem.Pos

    if BuySell == 'B' then
      elem.Pos = elem.Pos + trade.qty
    else
      elem.Pos = elem.Pos - trade.qty
    end

    if elem.Pos == 0 then
      elem.Avr = 0
    else
      if not isClosePos then  --      
        elem.Avr = (elem.Avr * math.abs(prevPos) + trade.price * trade.qty) / (math.abs(prevPos) + trade.qty)
      end
    end

    elem.Comm = elem.Comm + trade.clearing_comission + trade.exchange_comission + trade.tech_center_comission

  end

  if isClosePos then
    -- ToDo
  end

  OutPosGridLine(trade.seccode, elem)

  FillPosGridSummRow()


  -- add trade to table

  local new_row_idx = gridTrades.RowCount
  gridTrades.RowCount = new_row_idx + 1

  local openPosPrice
  if isClosePos then
    openPosPrice = prevAvr
  else
    openPosPrice = elem.Avr
  end


  gridTrades:SetCell(0, new_row_idx, trade.seccode)
  gridTrades:SetCell(1, new_row_idx, trade.qty)
  gridTrades:SetCell(2, new_row_idx, trade.price)
  gridTrades:SetCell(3, new_row_idx, trade.price * trade.qty * Lot)
  gridTrades:SetCell(4, new_row_idx, BuySell)
  gridTrades:SetCell(5, new_row_idx, openPosPrice)           -- " "
  if isClosePos then
    local pl
    if BuySell == 'B' then
      pl = openPosPrice - trade.price
    else
      pl = trade.price - openPosPrice
    end
    gridTrades:SetCell(6, new_row_idx, tostring(trade.price))  -- " "
    gridTrades:SetCell(7, new_row_idx, tostring(pl * trade.qty * Lot))  -- ""
    gridTrades:SetCell(8, new_row_idx, tostring(pl / trade.price * 100)) -- "% "
  end

end

function ProcessExistTrades()
  local TRADES_TABLE_NAME = "trades"

  local trades_num = getNumberOf(TRADES_TABLE_NAME)
  local i
  for i = 0, trades_num-1 do
    local trade = getItem(TRADES_TABLE_NAME, i)
    ProcessTrade(trade)
  end
end


--- QUIK event handlers ---

function OnInit(path)
  mainForm:Show()
  is_run = true    
  FillPosGridSummRow()
  ProcessExistPositions()
  ProcessExistTrades()
end

function main()
  while is_run do
    sleep(50)
  end
end

function OnStop()
  is_run = false
  mainForm:Free()
end

function OnClose()
  OnStop()
end

function OnTrade(trade)
  ProcessTrade(trade)
end

--- Form Event Handlers --

function MainFormCloseQuery(Sender, CanClose)
--  OnStop()
end

function MainFormClose(Sender, CloseAction)
--  is_run = false
--  CloseAction = caFree
end

